from chapter6_10 import *

from pprint import *

# Exemplary answer for Exercise 237
#
# Note: using map to essentially call a function for its
# side effect --- format for printing --- is frowned upon
# as contrary to the spirit of functional programming.
# And despite using pprint (pretty print) to display
# the resulting list one element per line, it's not as
# pretty as just printing in a loop, as the unwanted
# string delimiters and commas clutter the output.

def format_one_line(n, *moduli):
  residues=list(map(lambda m:n % m, moduli))
  return f'{n} <--> ({residues})'

def represBG(*moduli):
  """Repeating residues with
     bijectivity guaranteed
     made by modding
     range(lcm(*moduli))
     by each of an arbitrary
     number of moduli, one
     tuple of residues per row.
  """
  return list(map(lambda n:format_one_line(n, *moduli),
                  range(lcm(*moduli))))

pprint(represBG(3, 5))

# Exemplary answer for Exercise 335
#
# Kyle's code avoids at all costs the use of +, -, *, /, %, or mod!

from functools import reduce

flatten = lambda l:sum(map(flatten, l), []) if isinstance(l, list) else [l]

make_list = lambda a, b:flatten([a, b])

def create_residue_list_repeating(modulus, repetitions, existing_list=None):
    residue_list = []
    reduce(lambda _,__:residue_list.extend(existing_list or list(range(modulus))),
           range(-1,repetitions))
    return residue_list

def createRNSlookup(m1, m2, m3):
    second_third_lists = list(map(make_list, create_residue_list_repeating(m2, m3),
                                  create_residue_list_repeating(m3, m2)))
    second_third_lists_augmented = create_residue_list_repeating(0, m1, second_third_lists)
    first_second_third_list = list(map(make_list, create_residue_list_repeating(m1, len(second_third_lists)),
                                       second_third_lists_augmented))
    return dict(zip(range(len(first_second_third_list)), first_second_third_list))

rns_dict = createRNSlookup(7, 11, 13)

# These four functions you should have implemented:

def toRNS(n):
  return rns_dict[n]

def fromRNS(rns):
  return list(rns_dict.keys())[list(rns_dict.values()).index(rns)]

def add2(rns1, rns2):
  return (a7(rns1[0], rns2[0]),
          a11(rns1[1], rns2[1]),
          a13(rns1[2], rns2[2]))

def mul2(rns1, rns2):
  return (m7(rns1[0], rns2[0]),
          m11(rns1[1], rns2[1]),
          m13(rns1[2], rns2[2]))

print(do_test_rns_add2())

print(do_test_rns_mul2())
